
// TimerTstDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TimerTst.h"
#include "TimerTstDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTimerTstDlg dialog

int CTimerTstDlg::sm_iCount = 0;

//Current Dialog
CTimerTstDlg* CTimerTstDlg::sm_poCurrent = NULL;

CTimerTstDlg::CTimerTstDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTimerTstDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTimerTstDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTimerTstDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTimerTstDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTimerTstDlg, CDialog)
	//{{AFX_MSG_MAP(CTimerTstDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
	ON_REGISTERED_MESSAGE(CWndTimer::UWM_TIMER, OnWndTimer)
END_MESSAGE_MAP()

//Timer Function
void CTimerTstDlg::TimerFunc(LPVOID)
{
	sm_iCount++;
	if(sm_poCurrent != NULL && ::IsWindow(sm_poCurrent->m_hWnd))
	{
		CString oStr;
		oStr.Format("%d", sm_iCount);
		CEdit* poEdit = static_cast<CEdit*>(sm_poCurrent->GetDlgItem(IDC_EDIT1));
		poEdit->SetWindowText(oStr);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CTimerTstDlg message handlers

BOOL CTimerTstDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	//
	sm_poCurrent = this;
	//
	m_oWndTimer1.Create(m_hWnd, 1, 200);
	m_oWndTimer2.Create(m_hWnd, 2, 400);
	m_oWndTimer3.Create(TimerFunc, this, 1000);
	//
	m_oWndTimer1.Start();
	CWnd* poWnd = GetDlgItem(IDC_BUTTON1);
	poWnd->SetWindowText("Timer1 Running!");
	//
	m_oWndTimer2.Start();
	poWnd = GetDlgItem(IDC_BUTTON2);
	poWnd->SetWindowText("Timer2 Running!");
	//
	m_oWndTimer3.Start();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTimerTstDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTimerTstDlg::OnPaint() 
{
	if(IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTimerTstDlg::OnQueryDragIcon()
{
	return (HCURSOR)m_hIcon;
}

void CTimerTstDlg::OnButton1() 
{
	CString oStrMsg;
	if(true == m_oWndTimer1.IsRunning())
	{
		m_oWndTimer1.Stop();
		oStrMsg = _T("Timer1 Stopped!");
	}
	else
	{
		m_oWndTimer1.Start();
		oStrMsg = _T("Timer1 Running!");
	}
	CWnd* poWnd = GetDlgItem(IDC_BUTTON1);
	poWnd->SetWindowText(oStrMsg);	
}

void CTimerTstDlg::OnButton2() 
{
	CString oStrMsg;
	if(true == m_oWndTimer2.IsRunning())
	{
		m_oWndTimer2.Stop();
		oStrMsg = _T("Timer2 Stopped!");
	}
	else
	{
		m_oWndTimer2.Start();
		oStrMsg = _T("Timer2 Running!");
	}
	CWnd* poWnd = GetDlgItem(IDC_BUTTON2);
	poWnd->SetWindowText(oStrMsg);	
}

LRESULT CTimerTstDlg::OnWndTimer(WPARAM wParam, LPARAM lParam)
{
	if(m_oWndTimer1.GetID() == wParam)
		TRACE("\nTimer 1 ID %d Tick %d", wParam, lParam);
	else if(m_oWndTimer2.GetID() == wParam)
		TRACE("\nTimer 2 ID %d Tick %d", wParam, lParam);
	return 0;
}

