
// TimerTstDlg.h : header file
//

#if !defined(AFX_TIMERTSTDLG_H__FE7E4B5C_6BF6_11D6_9E8E_00E029363140__INCLUDED_)
#define AFX_TIMERTSTDLG_H__FE7E4B5C_6BF6_11D6_9E8E_00E029363140__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "WndTimer.h"

/////////////////////////////////////////////////////////////////////////////
// CTimerTstDlg dialog

class CTimerTstDlg : public CDialog
{
// Construction
public:
	CTimerTstDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CTimerTstDlg)
	enum { IDD = IDD_TIMERTST_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTimerTstDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

	//Get Current
	CTimerTstDlg* GetCurrent();

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CTimerTstDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButton1();
	afx_msg void OnButton2();
	//}}AFX_MSG
	afx_msg LRESULT OnWndTimer(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()

	static int sm_iCount;
	//Timer Function
	static void TimerFunc(LPVOID);

	//Current Dialog
	static CTimerTstDlg* sm_poCurrent;

private:
	//Timers
	CWndTimer m_oWndTimer1, m_oWndTimer2, m_oWndTimer3;
};

//Get Current
inline CTimerTstDlg* CTimerTstDlg::GetCurrent()
{
	return sm_poCurrent;
}

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TIMERTSTDLG_H__FE7E4B5C_6BF6_11D6_9E8E_00E029363140__INCLUDED_)

